package ij2x.gui;

import ij.IJ;
import ij.IJEventListener;
import ij.ImageJ;
import ij.Menus;
import ij.Prefs;
import ij.WindowManager;
import ij.gui.Toolbar;
import ij.plugin.frame.PlugInFrame;
import ij2x.plugin.Controll_Bar_Panel;

import java.awt.Frame;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;

//import javax.swing.JFrame;

public class ToolBox extends PlugInFrame implements ActionListener {
    /**
	 *
	 */
	private static final long serialVersionUID = -440308716931059829L;
	protected ImageJ ij;
    //protected JPanel panel = new JPanel();
    private Toolbar toolBar = new Toolbar();
    private Frame instance;
    static final String LOC_KEY = "tbf.loc";

    public ToolBox() {
        super("Tool Box");

    }

    public void run(String arg){
        instance=WindowManager.getFrame("Tool Box");
        if (instance!=null) {
            instance.toFront();
            toolBar.repaint();
            return;
        }

        ij = IJ.getInstance();
        Menus m = ij.getMenus();
        ij.installStartupMacroSet(m);
        toolBar.setToolbarDim(Toolbar.NUM_COLUMN_BUTTONS);
        add(toolBar);
        pack();
        WindowManager.addWindow(this);
        Point loc = Prefs.getLocation(LOC_KEY);
        if (loc!=null)
                setLocation(loc);
        //else GUI.relRight(ij, this);

        setResizable(false); // make resizable on Linux
        setVisible(true);
    }

    /** Closes this window. */
    public void close() {
        super.close();
        instance = null;
        Prefs.saveLocation(LOC_KEY, getLocation());
        IJ.notifyEventListeners(IJEventListener.COLOR_PICKER_CLOSED);
    }

    // Action listener method
    public void actionPerformed(ActionEvent e){
    }
     /** WindowsListener methods        */
     public void windowActivated(WindowEvent e) {
         ImageJ ij = IJ.getInstance();
         boolean quitting = ij!=null && ij.quitting();
     }

     public void windowClosing(WindowEvent e) {
                     Controll_Bar_Panel.toolboxButton.setEnabled(true);
                     //GUI.cwl--;
                     close();
     }

     public void windowClosed(WindowEvent e) {}
     public void windowDeactivated(WindowEvent e) {}
     public void windowDeiconified(WindowEvent e) {}
     public void windowIconified(WindowEvent e) {}
     public void windowOpened(WindowEvent e) {}


}

